diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index 5bbd895c..2c22886c 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -419,46 +503,58 @@ class SquadService extends Actor {
         if(leavingPlayer == leader || squad.Size == 2) {
           //squad leader is leaving his own squad, so it will be disbanded
           //alternately, squad is only composed of two people, so it will be closed-out when one of them leaves
-          val membership = squad.Membership.collect { case member if member.CharId > 0 => member.CharId }
-          membership.foreach { charId =>
-            SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", SquadResponse.Membership(SquadResponseType.Leave, 0, 0, charId, None, "", false, Some(None))))
-          }
-          CloseOutSquad(squad)
-          SquadEvents.publish(SquadServiceResponse(s"/$leader/Squad", SquadResponse.Membership(SquadResponseType.Disband, 0, 0, leader, None, "", true, Some(None))))
-          membership
-            .filterNot(_ == leader)
-            .foreach { charId =>
-            SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", SquadResponse.Membership(SquadResponseType.Disband, 0, 0, charId, None, "", false, Some(None))))
-          }
-          SquadEvents.publish( SquadServiceResponse(s"/$leader/Squad", SquadResponse.AssociateWithSquad(PlanetSideGUID(0))) )
-          SquadEvents.publish( SquadServiceResponse(s"/$leader/Squad", SquadResponse.Detail(PlanetSideGUID(0), SquadDetail().Complete)) )
+          DisbandSquad(squad)
         }
         else {
           if(optionalPlayer.contains(leavingPlayer)) {
             //leaving the squad of own accord
-            LeaveSquad(tplayer, squad)
+            LeaveSquad(tplayer.CharId, squad)
           }
           else if(optionalPlayer.contains(leader)) {
             //kicked by the squad leader
             SquadEvents.publish( SquadServiceResponse(s"/$leavingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Leave, 0, 0, leavingPlayer, Some(leader), tplayer.Name, false, Some(None))) )
             SquadEvents.publish( SquadServiceResponse(s"/$leader/Squad", SquadResponse.Membership(SquadResponseType.Leave, 0, 0, leader, Some(leavingPlayer), "", true, Some(None))) )
-            LeaveSquad(tplayer, squad)
+            squadFeatures(squad.GUID).Refuse = leavingPlayer
+            LeaveSquad(leavingPlayer, squad)
           }
         }
 
-      case SquadAction.Membership(SquadRequestType.Reject, rejectingPlayer, optionalPlayer, _, _) =>
+      case SquadAction.Membership(SquadRequestType.Reject, rejectingPlayer, _, _, _) =>
         val rejectedBid = RemoveInvite(rejectingPlayer)
         //(A, B) -> person who made the rejection, person who was rejected
         (rejectedBid match {
           case Some(SpontaneousInvite(invitingPlayer)) =>
             //rejectingPlayer is the would-be squad member
             (Some(rejectingPlayer), Some(invitingPlayer.CharId))
-          case Some(VacancyInvite(invitingPlayer, _, guid)) if idToSquad(guid).Leader.CharId != rejectingPlayer =>
+          case Some(VacancyInvite(invitingPlayer, _, guid))
+            if squadFeatures.get(guid).nonEmpty && squadFeatures(guid).Squad.Leader.CharId != rejectingPlayer =>
             //rejectingPlayer is the would-be squad member
             (Some(rejectingPlayer), Some(invitingPlayer))
-          case Some(BidForPosition(_, guid, _)) if idToSquad(guid).Leader.CharId != rejectingPlayer =>
+          case Some(BidForRole(_, guid, _))
+            if squadFeatures.get(guid).nonEmpty && squadFeatures(guid).Squad.Leader.CharId == rejectingPlayer =>
             //rejectingPlayer is the squad leader
             (Some(rejectingPlayer), None)
+          case Some(InviteForRole(invitingPlayer, _, guid, position))
+            if squadFeatures.get(guid).nonEmpty && squadFeatures(guid).Squad.Leader.CharId != rejectingPlayer =>
+            //rejectingPlayer is the would-be squad member
+            val features = squadFeatures(guid)
+            features.Refuse = rejectingPlayer //do not bother this player anymore
+            features.ProxyInvites = features.ProxyInvites.filterNot(_ == rejectingPlayer)
+            if(features.ProxyInvites.isEmpty) {
+              features.SearchForRole = None
+            }
+            (None, None)
+          case Some(ProximityInvite(_, _, guid))
+            if squadFeatures.get(guid).nonEmpty && squadFeatures(guid).Squad.Leader.CharId != rejectingPlayer =>
+            //rejectingPlayer is the would-be squad member
+            val features = squadFeatures(guid)
+            features.Refuse = rejectingPlayer //do not bother this player anymore
+            features.ProxyInvites = features.ProxyInvites.filterNot(_ == rejectingPlayer)
+            if(features.ProxyInvites.isEmpty) {
+              //all invitations exhausted; this invitation is concluded
+              features.SearchForRole = None
+            }
+            (None, None)
           case _ => ;
             (None, None)
         }) match {
@@ -469,46 +565,11 @@ class SquadService extends Actor {
             SquadEvents.publish( SquadServiceResponse(s"/$rejected/Squad", SquadResponse.Membership(SquadResponseType.Reject, 0, 0, rejected, Some(rejected), "", true, Some(None))) )
           case _ => ;
         }
-        NextInvite(rejectingPlayer) match {
-          case Some(bid : BidForPosition) if rejectedBid.isEmpty || !rejectedBid.contains(bid) =>
-            HandleBidForPosition(bid, tplayer)
-          case Some(bid) if rejectedBid.isEmpty || !rejectedBid.contains(bid) =>
-            SquadEvents.publish(SquadServiceResponse(s"/$rejectingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, bid.InviterCharId, Some(rejectingPlayer), bid.InviterName, false, Some(None))))
-          case None => ;
-        }
+        NextInviteAndRespond(rejectingPlayer)
 
-//      case SquadAction.Membership(SquadRequestType.Cancel, cancellingPlayer, _, _, _) =>
-//        //look for queued BidForPosition entries where we are the player who wants to join
-//        queuedInvites.foreach { case (leader, queueOfInvites) =>
-//          val list = queueOfInvites.filterNot { entry =>
-//              entry.isInstanceOf[BidForPosition] &&
-//                entry.asInstanceOf[BidForPosition].player.CharId == cancellingPlayer
-//          }
-//          if(list.nonEmpty && list.size != queueOfInvites.size) {
-//            queuedInvites(leader) = list
-//          }
-//          else if(list.isEmpty) {
-//            queuedInvites.remove(leader)
-//          }
-//        }
-//        //clean up active BidForPosition invite entries where we are the player who wants to join
-//        val list = invites.filter { case(_, entry) =>
-//          entry.isInstanceOf[BidForPosition] &&
-//            entry.asInstanceOf[BidForPosition].player.CharId == cancellingPlayer
-//        }
-//        list.foreach {
-//          case(charId, entry : BidForPosition) =>
-//            RemoveInvite(charId)
-//            SquadEvents.publish( SquadServiceResponse(s"/$charId/Squad", SquadResponse.Membership(SquadResponseType.Cancel, 0, 0, cancellingPlayer, None, entry.player.Name, false, None)))
-//            NextInvite(charId) match {
-//              case Some(bid : BidForPosition) =>
-//                HandleBidForPosition(bid, tplayer)
-//              case Some(bid) =>
-//                SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, bid.InviterCharId, Some(charId), bid.InviterName, false, Some(None))))
-//              case _ => ;
-//            }
-//          case _ => ;
-//        }
+      case SquadAction.Membership(SquadRequestType.Cancel, cancellingPlayer, _, _, _) =>
+        //huh?
+        log.warn(s"Huh? what does player $cancellingPlayer want to cancel?")
 
       case SquadAction.Membership(SquadRequestType.Promote, promotingPlayer, Some(promotedPlayer), _, _) =>
         (memberToSquad.get(promotingPlayer), memberToSquad.get(promotedPlayer)) match {
@@ -518,6 +579,27 @@ class SquadService extends Actor {
             val (member, index) = membership.zipWithIndex.find { case (_member, _) => _member.CharId == promotedPlayer }.get
             log.info(s"Player ${leader.Name} steps down from leading ${squad.Task}")
             SwapMemberPosition(squad, leader, member)
+            //move around invites so that the proper squad leader deals with them
+            val leaderInvite = invites.remove(promotingPlayer)
+            val leaderQueuedInvites = queuedInvites.remove(promotingPlayer).toList.flatten
+            invites.get(promotedPlayer).orElse(previousInvites.get(promotedPlayer)) match {
+              case Some(_) =>
+                //the promoted player has an active invite; queue these
+                queuedInvites += promotedPlayer -> (leaderInvite.toList ++ leaderQueuedInvites ++ queuedInvites.remove(promotedPlayer).toList.flatten)
+              case None if leaderInvite.nonEmpty =>
+                //no active invite for the promoted player, but the leader had an active invite; trade the queued invites
+                val invitation = leaderInvite.get
+                AddInviteAndRespond(promotedPlayer, invitation, invitation.InviterCharId, invitation.InviterName)
+                queuedInvites += promotedPlayer -> (leaderQueuedInvites ++ queuedInvites.remove(promotedPlayer).toList.flatten)
+              case None =>
+                //no active invites for anyone; assign the first queued invite from the promoting player, if available, and queue the rest
+                leaderQueuedInvites match {
+                  case Nil => ;
+                  case x :: xs =>
+                    AddInviteAndRespond(promotedPlayer, x, x.InviterCharId, x.InviterName)
+                    queuedInvites += promotedPlayer -> (xs ++ queuedInvites.remove(promotedPlayer).toList.flatten)
+                }
+            }
             log.info(s"Promoting player ${leader.Name} to be the leader of ${squad.Task}")
             membership.foreach { _member =>
               SquadEvents.publish(SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.PromoteMember(squad, promotedPlayer, index, position)))
@@ -539,7 +621,8 @@ class SquadService extends Actor {
                 ))
             )
 
-          case _ => ;
+          case msg =>
+            log.warn(s"Unsupported squad behavior: $msg")
         }
 
       case SquadAction.Waypoint(_, wtype, _, info) =>
@@ -555,7 +638,7 @@ class SquadService extends Actor {
             }
           case _ => (None, None)
         }) match {
-          case (Some(squad), Some(waypoint)) =>
+          case (Some(squad), Some(_)) =>
             //waypoint added or updated
             squad.Membership
               .filterNot { member => member.CharId == tplayer.CharId }
@@ -565,6 +648,7 @@ class SquadService extends Actor {
                   SquadServiceResponse(s"/$charId/Squad", SquadResponse.WaypointEvent(WaypointEventAction.Add, playerCharId, wtype, None, info, 1))
                 )
               }
+
           case (Some(squad), None) =>
             //waypoint removed?
             squad.Membership
@@ -575,10 +659,12 @@ class SquadService extends Actor {
                   SquadServiceResponse(s"/$charId/Squad", SquadResponse.WaypointEvent(WaypointEventAction.Remove, playerCharId, wtype, None, None, 0))
                 )
               }
-          case _ => ;
+
+          case msg =>
+            log.warn(s"Unsupported squad waypoint behavior: $msg")
         }
 
-      case SquadAction.Definition(zone, guid, line, action) =>
+      case SquadAction.Definition(guid, line, action) =>
         import net.psforever.packet.game.SquadAction._
         val pSquadOpt = GetParticipatingSquad(tplayer)
         val lSquadOpt = GetLeadingSquad(tplayer, pSquadOpt)
@@ -633,14 +719,11 @@ class SquadService extends Actor {
                 squad.Availability.update(position, false)
                 log.info(s"${tplayer.Name}-${tplayer.Faction} has closed the #$position position in squad")
                 val memberPosition = squad.Membership(position)
-                val listingChanged = if(memberPosition.Name.nonEmpty) {
-                  SquadInfo().Size(squad.Size).Capacity(squad.Capacity)
-                }
-                else {
-                  SquadInfo().Capacity(squad.Capacity)
+                if(memberPosition.CharId > 0) {
+                  LeaveSquad(memberPosition.CharId, squad)
                 }
                 memberPosition.Close()
-                UpdateSquadListWhenListed(squad, listingChanged)
+                UpdateSquadListWhenListed(squad, SquadInfo().Capacity(squad.Capacity))
                 UpdateSquadDetail(squad.GUID, squad,
                   SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail.Closed)))
                 )
@@ -716,6 +799,113 @@ class SquadService extends Actor {
             val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             squad.AutoApproveInvitationRequests = state
 
+          case FindLfsSoldiersForRole(position) =>
+            lSquadOpt match {
+              case Some(squad) =>
+                val sguid = squad.GUID
+                val features = squadFeatures(sguid)
+                features.SearchForRole match {
+                  case Some(-1) =>
+                    //a proximity invitation has not yet cleared; nothing will be gained by trying to invite for a specific role
+                    log.debug("FindLfsSoldiersForRole: waiting for proximity invitations to clear")
+                  case _ =>
+                    //either no role has ever been recruited, or some other role has been recruited
+                    //normal LFS recruitment for the given position
+                    val excusedInvites = features.Refuse
+                    val faction = squad.Faction
+                    val requirementsToMeet = squad.Membership(position).Requirements
+                    val outstandingActiveInvites = features.SearchForRole match {
+                      case Some(pos) =>
+                        RemoveQueuedInvitesForSquadAndPosition(sguid, pos)
+                        invites.collect { case(charId, InviteForRole(_,_, squad_guid, role)) if squad_guid == sguid && role == pos => charId }
+                      case None =>
+                        List.empty[Long]
+                    }
+                    features.SearchForRole = position
+                    //this will update the role entry in the GUI to visually indicate being searched for; only one will be displayed at a time
+                    SquadEvents.publish(
+                      SquadServiceResponse(s"/${tplayer.CharId}/Squad", SquadResponse.Detail(
+                        sguid,
+                        SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail().CharId(char_id = 0L).Name(name = ""))))
+                      ))
+                    )
+                    //collect all players that are eligible for invitation to the new position
+                    //divide into players with an active invite (A) and players with a queued invite (B)
+                    //further filter (A) into players whose invitation is renewed (A1) and new invitations (A2)
+                    //TODO only checks the leader's current zone; should check all zones
+                    (zone.LivePlayers
+                      .collect { case player
+                        if !excusedInvites.contains(player.CharId) &&
+                          faction == player.Faction && player.LFS && memberToSquad.get(player.CharId).isEmpty &&
+                          requirementsToMeet.intersect(player.Certifications) == requirementsToMeet =>
+                        player.CharId
+                      }
+                      .partition { charId => outstandingActiveInvites.exists(charId == _) } match {
+                      case (Nil, Nil) =>
+                        outstandingActiveInvites foreach RemoveInvite
+                        features.ProxyInvites = Nil
+                        //TODO cancel the LFS search from the server so that the client updates properly; how?
+                        None
+                      case (outstandingPlayerList, invitedPlayerList) =>
+                        //players who were actively invited for the previous position and are eligible for the new position
+                        outstandingPlayerList.foreach { charId =>
+                          val bid = invites(charId).asInstanceOf[InviteForRole]
+                          invites(charId) = InviteForRole(bid.char_id, bid.name, sguid, position)
+                        }
+                        //players who were actively invited for the previous position but are ineligible for the new position
+                        (features.ProxyInvites filterNot (outstandingPlayerList contains)) foreach RemoveInvite
+                        features.ProxyInvites = outstandingPlayerList ++ invitedPlayerList
+                        Some(invitedPlayerList)
+                    }) match {
+                      //add invitations for position in squad
+                      case Some(invitedPlayers) =>
+                        val invitingPlayer = tplayer.CharId
+                        val name = tplayer.Name
+                        invitedPlayers.foreach { invitedPlayer =>
+                          AddInviteAndRespond(
+                            invitedPlayer,
+                            InviteForRole(invitingPlayer, name, sguid, position),
+                            invitingPlayer,
+                            name
+                          )
+                        }
+                      case None => ;
+                    }
+                }
+
+              case _ => ;
+            }
+
+          case CancelFind() =>
+            lSquadOpt match {
+              case Some(squad) =>
+                val sguid = squad.GUID
+                val position = squadFeatures(sguid).SearchForRole
+                squadFeatures(sguid).SearchForRole = None
+                //remove active invites
+                invites.filter {
+                  case (_, InviteForRole(_, _, _guid, pos)) => _guid == sguid && position.contains(pos)
+                  case _ => false
+                }
+                  .keys.foreach { charId =>
+                  RemoveInvite(charId)
+                }
+                //remove queued invites
+                queuedInvites.foreach { case (charId, queue) =>
+                  val filtered = queue.filterNot {
+                    case InviteForRole(_, _, _guid, _) => _guid == sguid
+                    case _ => false
+                  }
+                  queuedInvites += charId -> filtered
+                  if(filtered.isEmpty) {
+                    queuedInvites.remove(charId)
+                  }
+                }
+                //remove yet-to-be invitedPlayers
+                squadFeatures(sguid).ProxyInvites = Nil
+              case _ => ;
+            }
+
           case RequestListSquad() =>
             val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             if(!squad.Listed && squad.Task.nonEmpty && squad.ZoneId > 0) {
@@ -738,6 +928,7 @@ class SquadService extends Actor {
           case ResetAll() =>
             lSquadOpt match {
               case Some(squad) if squad.Size > 1 =>
+                val guid = squad.GUID
                 squad.Task = ""
                 squad.ZoneId = None
                 squad.Availability.indices.foreach { i =>
@@ -751,19 +942,172 @@ class SquadService extends Actor {
                 squad.LocationFollowsSquadLead = false
                 squad.AutoApproveInvitationRequests = false
                 UpdateSquadListWhenListed(squad, SquadInfo().Task("").ZoneId(None).Capacity(squad.Capacity))
-                UpdateSquadDetail(squad.GUID, squad)
+                UpdateSquadDetail(guid, squad)
                 sender ! SquadServiceResponse("", SquadResponse.AssociateWithSquad(PlanetSideGUID(0)))
-                if(!initialAssociation.contains(squad.GUID)) {
-                  initialAssociation += squad.GUID
-                }
+                squadFeatures(guid).InitialAssociation = true
                 //do not unlist an already listed squad
               case Some(squad) =>
                 //underutilized squad; just close it out
-                CloseOutSquad(squad)
+                CloseSquad(squad)
               case _ => ;
             }
 
           case _ =>
+            (pSquadOpt, action) match {
+              //the following action can be performed by the squad leader and maybe an unaffiliated player
+              case (Some(squad), SelectRoleForYourself(position)) =>
+                log.info(s"${tplayer.Name} would like the #${position+1} spot in the same squad")
+                val membership = squad.Membership.zipWithIndex
+                val toMember = squad.Membership(position)
+                if(squad.Leader.CharId == tplayer.CharId) {
+                  //TODO squad leader currently disallowed
+                } else
+                //the squad leader may swap to any open position; a normal member has to validate against requirements
+                if((squad.Leader.CharId == tplayer.CharId && toMember.CharId == 0) || ValidOpenSquadPosition(squad, position, toMember, tplayer.Certifications)) {
+                  membership.find { case (member, _) => member.CharId == tplayer.CharId } match {
+                    case Some((fromMember, fromIndex)) =>
+                      SwapMemberPosition(squad, toMember, fromMember)
+                      if(fromIndex == squad.LeaderPositionIndex) {
+                        squad.LeaderPositionIndex = position
+                      }
+                      //RemoveInvite(tplayer.CharId).foreach { _ =>
+                      //close the old bids out
+                      //}
+                      membership
+                        .filter { case (_member, _) => _member.CharId > 0 }
+                        .foreach { case (_member, _) =>
+                          SquadEvents.publish(SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.AssignMember(squad, fromIndex, position)))
+                        }
+                      UpdateSquadDetail(squad.GUID, squad)
+                    case _ => ;
+                    //somehow, this is not our squad; do nothing, for now
+                  }
+                }
+                else {
+                  //not qualified for requested position
+                }
+
+              //the following action can be performed by an unaffiliated player
+              case (None, SelectRoleForYourself(position)) =>
+                //not a member of any squad, but we might become a member of this one
+                GetSquad(guid) match {
+                  case Some(squad) =>
+                    val toMember = squad.Membership(position)
+                    if(ValidOpenSquadPosition(squad, position, toMember, tplayer.Certifications)) {
+                      //we could join but we may need permission from the squad leader first
+                      log.info(s"${tplayer.Name} would like the #${position+1} spot in the squad ${squad.Task}.")
+                      AddInviteAndRespond(
+                        squad.Leader.CharId,
+                        BidForRole(tplayer, guid, position),
+                        invitingPlayer = 0L, //we ourselves technically are ...
+                        tplayer.Name
+                      )
+                    }
+                  case None => ;
+                  //squad does not exist? assume old local data; force update to correct discrepancy
+                }
+
+              //the following action can be performed by anyone who has tried to join a squad
+              case (_, CancelSelectRoleForYourself(_)) =>
+                val cancellingPlayer = tplayer.CharId
+                GetSquad(guid) match {
+                  case Some(squad) =>
+                    //assumption: a player who is cancelling will rarely end up with their invite queued
+                    val leaderCharId = squad.Leader.CharId
+                    //clean up any active BidForRole invite entry where we are the player who wants to join the leader's squad
+                    ((invites.get(leaderCharId) match {
+                      case out @ Some(entry) if entry.isInstanceOf[BidForRole] &&
+                        entry.asInstanceOf[BidForRole].player.CharId == cancellingPlayer =>
+                        out
+                      case _ =>
+                        None
+                    }) match {
+                      case Some(entry : BidForRole) =>
+                        RemoveInvite(leaderCharId)
+                        SquadEvents.publish( SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.Membership(SquadResponseType.Cancel, 0, 0, cancellingPlayer, None, entry.player.Name, false, Some(None))))
+                        NextInviteAndRespond(leaderCharId)
+                        Some(true)
+                      case _ =>
+                        None
+                    }).orElse(
+                      //look for a queued BidForRole entry where we are the player who wants to join the leader's squad
+                      (queuedInvites.get(leaderCharId) match {
+                        case Some(_list) =>
+                          (_list, _list.indexWhere { entry =>
+                            entry.isInstanceOf[BidForRole] &&
+                              entry.asInstanceOf[BidForRole].player.CharId == cancellingPlayer
+                          })
+                        case None =>
+                          (Nil, -1)
+                      }) match {
+                        case (_, -1) =>
+                          None //no change
+                        case (list, index) if list.size == 1 =>
+                          val entry = list.head.asInstanceOf[BidForRole]
+                          SquadEvents.publish( SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.Membership(SquadResponseType.Cancel, 0, 0, cancellingPlayer, None, entry.player.Name, false, Some(None))))
+                          queuedInvites.remove(leaderCharId)
+                          Some(true)
+                        case (list, index) =>
+                          val entry = list(index).asInstanceOf[BidForRole]
+                          SquadEvents.publish( SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.Membership(SquadResponseType.Cancel, 0, 0, cancellingPlayer, None, entry.player.Name, false, Some(None))))
+                          queuedInvites(leaderCharId) = list.take(index) ++ list.drop(index+1)
+                          Some(true)
+                      }
+                    )
+
+                  case _ => ;
+                }
+
+              //the following action can be performed by ???
+              case (Some(squad), AssignSquadMemberToRole(position, char_id)) =>
+                val membership = squad.Membership.zipWithIndex
+                (membership.find({ case (member, _) => member.CharId == char_id}), membership(position)) match {
+                  //TODO squad leader currently disallowed
+                  case (Some((fromMember, fromPosition)), (toMember, _)) if fromPosition != 0 =>
+                    val name = fromMember.Name
+                    SwapMemberPosition(squad, toMember, fromMember)
+                    if(fromPosition == squad.LeaderPositionIndex) {
+                      squad.LeaderPositionIndex = position
+                    }
+                    membership
+                      .filter({ case (_member, _) => _member.CharId > 0 })
+                      .foreach { case (_member, _) =>
+                        SquadEvents.publish(SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.AssignMember(squad, fromPosition, position)))
+                      }
+                    UpdateSquadDetail(squad.GUID, squad,
+                      SquadDetail().Members(List(
+                        SquadPositionEntry(position, SquadPositionDetail().CharId(fromMember.CharId).Name(fromMember.Name)),
+                        SquadPositionEntry(fromPosition, SquadPositionDetail().CharId(char_id).Name(name))
+                      ))
+                    )
+                  case _ => ;
+                }
+
+              //the following action can be peprformed by anyone
+              case (_, SearchForSquadsWithParticularRole(_/*role*/, _/*requirements*/, _/*zone_id*/, _/*search_mode*/)) =>
+                //though we should be able correctly search squads as is intended
+                //I don't know how search results should be prioritized or even how to return search results to the user
+                sender ! SquadServiceResponse("", SquadResponse.SquadSearchResults())
+
+              //the following action can be performed by anyone
+              case (_, DisplaySquad()) =>
+                GetSquad(guid) match {
+                  case Some(squad) =>
+                    sender ! SquadServiceResponse("", SquadResponse.Detail(squad.GUID, SquadService.Detail.Publish(squad)))
+                  case None => ;
+                }
+
+              //the following message is feedback from a specific client, awaiting proper initialization
+              case (_, SquadMemberInitializationIssue()) =>
+              //            GetSquad(guid) match {
+              //              case Some(squad) =>
+              //                sender ! SquadServiceResponse("", SquadResponse.Detail(squad.GUID, SquadService.Detail.Publish(squad)))
+              //              case None => ;
+              //            }
+
+              case msg => ;
+                log.warn(s"Unsupported squad definition behavior: $msg")
+            }
         }
         // etc..
         (pSquadOpt, action) match {
@@ -803,20 +1147,18 @@ class SquadService extends Actor {
           //the following action can be performed by an unaffiliated player
           case (None, SelectRoleForYourself(position)) =>
             //not a member of any squad, but we might become a member of this one
-            idToSquad.get(guid) match {
+            GetSquad(guid) match {
               case Some(squad) =>
                 val toMember = squad.Membership(position)
                 if(ValidOpenSquadPosition(squad, position, toMember, tplayer.Certifications)) {
                   //we could join but we may need permission from the squad leader first
                   log.info(s"Player ${tplayer.Name} would like to join the squad ${squad.Task}.")
-                  val leader = squad.Leader
-                  val bid = BidForPosition(tplayer, guid, position)
-                  val leaderCharId = leader.CharId
-                  AddInvite(leaderCharId, bid) match {
-                    case out @ Some(_) if out.contains(bid) =>
-                      HandleBidForPosition(bid, tplayer)
-                    case _ => ;
-                  }
+                  AddInviteAndRespond(
+                    squad.Leader.CharId,
+                    BidForRole(tplayer, guid, position),
+                    invitingPlayer = 0L, //we ourselves technically are ...
+                    tplayer.Name
+                  )
                 }
               case None => ;
               //squad does not exist? assume old local data; force update to correct discrepancy
